﻿using System;
using System.Web;
using System.Web.SessionState;
using System.IO;
using System.Data;
using System.Collections.Generic;


namespace igTreePOC
{
    public class TreeService : IHttpHandler, IRequiresSessionState
    {
        private const string RESULTS_ROOT = "{\"d\":[{\"DisplayString\":\"Wheat\",\"TreeNodeString\":\"3?1001-0=\",\"TreeNodeList\":[]},{\"DisplayString\":\"Barley\",\"TreeNodeString\":\"3?1002-0=\",\"TreeNodeList\":[]},{\"DisplayString\":\"Beans\",\"TreeNodeString\":\"3?1003-0=\",\"TreeNodeList\":[]}]}";
        private const string RESULTS_WHEAT = "{\"d\":[{\"DisplayString\":\"Wheat-CPSR\",\"TreeNodeString\":\"3?1001-0=9\",\"TreeNodeList\":[]},{\"DisplayString\":\"Wheat-CWAD\",\"TreeNodeString\":\"3?1001-0=4\",\"TreeNodeList\":[]},{\"DisplayString\":\"Wheat-CWES\",\"TreeNodeString\":\"3?1001-0=7\",\"TreeNodeList\":[]},{\"DisplayString\":\"Wheat-CWGP\",\"TreeNodeString\":\"3?1001-0=8\",\"TreeNodeList\":[]},{\"DisplayString\":\"Wheat-CWHWS\",\"TreeNodeString\":\"3?1001-0=3\",\"TreeNodeList\":[]},{\"DisplayString\":\"Wheat-CWRS\",\"TreeNodeString\":\"3?1001-0=2\",\"TreeNodeList\":[]},{\"DisplayString\":\"Wheat-CWRW\",\"TreeNodeString\":\"3?1001-0=5\",\"TreeNodeList\":[]},{\"DisplayString\":\"Wheat-CWSWS\",\"TreeNodeString\":\"3?1001-0=6\",\"TreeNodeList\":[]}]}";
        private const string RESULTS_BARLEY = "{\"d\":[{\"DisplayString\":\"Barley-Feed CW Hulled\",\"TreeNodeString\":\"3?1002-0=70\",\"TreeNodeList\":[]},{\"DisplayString\":\"Barley-Feed CW Hulless\",\"TreeNodeString\":\"3?1002-0=71\",\"TreeNodeList\":[]},{\"DisplayString\":\"Barley-Food CW Hulled\",\"TreeNodeString\":\"3?1002-0=12\",\"TreeNodeList\":[]},{\"DisplayString\":\"Barley-Food CW Hulless\",\"TreeNodeString\":\"3?1002-0=13\",\"TreeNodeList\":[]}]}";
        private const string RESULTS_BEANS = "{\"d\":[{\"DisplayString\":\"Beans-Black\",\"TreeNodeString\":\"3?1003-0=17\",\"TreeNodeList\":[]},{\"DisplayString\":\"Beans-Great Northern\",\"TreeNodeString\":\"3?1003-0=19\",\"TreeNodeList\":[]},{\"DisplayString\":\"Beans-Navy\",\"TreeNodeString\":\"3?1003-0=18\",\"TreeNodeList\":[]},{\"DisplayString\":\"Beans-Pinto\",\"TreeNodeString\":\"3?1003-0=16\",\"TreeNodeList\":[]},{\"DisplayString\":\"Beans-Shiny Black\",\"TreeNodeString\":\"3?1003-0=21\",\"TreeNodeList\":[]},{\"DisplayString\":\"Beans-Small Red\",\"TreeNodeString\":\"3?1003-0=20\",\"TreeNodeList\":[]},{\"DisplayString\":\"Beans-Yellow\",\"TreeNodeString\":\"3?1003-0=22\",\"TreeNodeList\":[]}]}";

        public bool IsReusable
        {
            get
            {
                //J. Foster - Nov 1, 2012
                //I don't know whether this should be true or false, but let's try to build it to be reusable.
                return true;
            }
        }

        /// <summary>
        /// Intercepts the request, and determines where to route it, based on the HTTP Verb.
        /// </summary>
        /// <param name="httpContext"></param>
        public void ProcessRequest(HttpContext httpContext)
        {
            //Handling CRUD
            switch (httpContext.Request.HttpMethod)
            {
                case "GET":
                    //Perform READ Operation
                    Read(httpContext);
                    break;
            }
        }

        /// <summary>
        /// Gets the data from the data manager, based on the context string in the Query String.
        /// </summary>
        private void Read(HttpContext httpContext)
        {
            string queryString = httpContext.Request.QueryString.ToString();
            string result = "";

            string path = httpContext.Request.QueryString["path"];

            if (string.IsNullOrWhiteSpace(path))
            {
                result = RESULTS_ROOT;
            }
            else
            {
                string contextString = path.Substring(path.IndexOf(':') + 1);
                contextString = contextString.Substring(0, contextString.IndexOf('/'));

                switch (contextString)
                {
                    case "3?1001-0=":
                        result = RESULTS_WHEAT;
                        break;
                    case "3?1002-0=":
                        result = RESULTS_BARLEY;
                        break;
                    case "3?1003-0=":
                        result = RESULTS_BEANS;
                        break;
                }
            }

            //httpContext.Response.ContentType = "text/json";
            httpContext.Response.ContentType = "application/json";
            //httpContext.Response.Write('(' + result + ')');
            httpContext.Response.Write(result);
        }
    }
}
